/* Damn it emacs this is -*- c++ -*-, and this has to be the first line :-(
 *
 * KANTS - KDE Applet for the ANTS system
 *
 * (C) 2001 by Klaus S. Madsen  (ksm@sysorb.com / ksm@hjernemadsen.org)
 *
 * $Id: kantsapplet.h,v 1.1 2002/04/04 18:08:33 jcd Exp $
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later
 *  version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA
 *
 */

#ifndef __KANTSAPPLET_HH
#define __KANTSAPPLET_HH

#include <kpanelapplet.h>
#include <kaboutdata.h>
#include <ksimpleconfig.h>
#include <qsocketnotifier.h>
#include <map>

#include "../src/antslib.h"

struct AntsMember {
  unsigned max;
  unsigned preferred;
  unsigned running;
  unsigned reserved;    
};

typedef std::map<int, AntsMember> AntsJobStats;

struct AntsJob {
  unsigned max;
  AntsJobStats jobStats;
};

typedef std::map<QString, AntsJob> AntsJobs;

class KAntsApplet : public KPanelApplet
{
  Q_OBJECT

 public:
  KAntsApplet(const QString& configFile, Type t = Stretch,
	      int actions = 0, QWidget *parent = 0,
	      const char *name = 0);
  int widthForHeight(int height) const;
  int heightForWidth(int width) const;
 public slots:
  void dataReceived();
 protected:
  virtual void about();
  virtual void drawContents(QPainter*);
  virtual void mousePressEvent(QMouseEvent *);
 private:
  int usock;
  void horzBarValues(int, int&, int&) const;
  void drawHorzCells(QPainter*, int, int, int, int&);
  int vertBarValues(int) const;
  void drawVertCells(QPainter*, int, int, int, int&);
  void connectSocket();
  void closeSocket();
  KAboutData *aboutData;
  QSocketNotifier * notify;
  
  KSimpleConfig* config;
  QString preferredJobType;
  AntsJobs jobs;
  AntsJobs::const_iterator curJob;
};

#endif
